#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <channel.h>

#include "table.h"        /* C table output by the MMS */

void out(Process *p, const char *table, int table_size)
{
  ChanOut(LINK1OUT, (void *) table, table_size);
}

void in(Process *p, int *num_t2s)
{
  *num_t2s = ChanInInt(LINK1IN);
}

int boot(const char *table, int table_size)
{
  Process *p1, *p2;
  int num_t2s;

  p1 = ProcAlloc(out, 0, 2, table, table_size);
  if (p1 == NULL)
    abort();

  p2 = ProcAlloc(in, 0, 1, &num_t2s);
  if (p2 == NULL)
    abort();

  ProcPar(p1,p2,NULL);

  return(num_t2s);
}

int main()
{
  int num_t2s;

  printf("Booting T2 chain ...\n");

  num_t2s = boot(Table, Table_size) + 1;

  printf("Booted - size of T2 chain is %d\n", num_t2s);

  return(0);
}
